﻿using Org.BouncyCastle.Bcpg;
using Org.BouncyCastle.Utilities.Encoders;
using PSO2SERVER.Models;
using PSO2SERVER.Packets.PSOPackets;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Policy;
using System.Text;
using System.Threading.Tasks;

namespace PSO2SERVER.Packets.Handlers
{
    [PacketHandlerAttr(0x0B, 0x19)]
    class QuestDifficultyRequestHandler : PacketHandler
    {
        public override void HandlePacket(Client context, byte flags, byte[] data, uint position, uint size)
        {
            var reader = new PacketReader(data, position, size);

            var info = string.Format("[<--] 接收到的数据 (hex): {0}字节", data.Length);
            Logger.WriteHex(info, data);
//[< --] 接收到的数据(hex): 16字节
//00000000 7F A3 00 00 20 00 00 00  00 00 00 00 0B 00 00 00       ￡............
//[-->] 0x0B - 0x1C(NoPayloadPacket)(Flags None)(8 字节)
//[< --] 0x0B - 0x19(QuestDifficultyRequestHandler)(Flags PACKED)(24 字节)
//[< --] 接收到的数据(hex): 16字节
//00000000 7F A3 00 00 20 00 00 00  00 00 00 00 0B 00 00 00       ￡............
//[-->] 0x0B - 0x1C(NoPayloadPacket)(Flags None)(8 字节)
//[< --] 0x0B - 0x19(QuestDifficultyRequestHandler)(Flags PACKED)(24 字节)
//[< --] 接收到的数据(hex): 16字节
//00000000 7F A3 00 00 20 00 00 00  00 00 00 00 0B 00 00 00       ￡............
//[-->] 0x0B - 0x1C(NoPayloadPacket)(Flags None)(8 字节)
//[< --] 0x0B - 0x19(QuestDifficultyRequestHandler)(Flags PACKED)(24 字节)
//[< --] 接收到的数据(hex): 16字节
//00000000 7F A3 00 00 20 00 00 00  00 00 00 00 0B 00 00 00       ￡............
//[-->] 0x0B - 0x1C(NoPayloadPacket)(Flags None)(8 字节)
//[< --] 0x0B - 0x19(QuestDifficultyRequestHandler)(Flags PACKED)(24 字节)
//[< --] 接收到的数据(hex): 16字节
//00000000 7F A3 00 00 20 00 00 00  00 00 00 00 0B 00 00 00       ￡............
//[-->] 0x0B - 0x1C(NoPayloadPacket)(Flags None)(8 字节)
//[< --] 0x0B - 0x19(QuestDifficultyRequestHandler)(Flags PACKED)(24 字节)
//[< --] 接收到的数据(hex): 16字节
//00000000 7F A3 00 00 20 00 00 00  00 00 00 00 0B 00 00 00       ￡............
//[-->] 0x0B - 0x1C(NoPayloadPacket)(Flags None)(8 字节)
//[< --] 0x0B - 0x19(QuestDifficultyRequestHandler)(Flags PACKED)(24 字节)
//[< --] 接收到的数据(hex): 16字节
//00000000 7F A3 00 00 20 00 00 00  00 00 00 00 0B 00 00 00       ￡............
//[-->] 0x0B - 0x1C(NoPayloadPacket)(Flags None)(8 字节)
//[< --] 0x0B - 0x19(QuestDifficultyRequestHandler)(Flags PACKED)(24 字节)

            //QuestDifficultyPacket.QuestDifficulty[] diffs = new QuestDifficultyPacket.QuestDifficulty[1];
            //for (int i = 0; i < diffs.Length; i++)
            //{
            //    diffs[i].dateOrSomething = "2017/2/20";
            //    diffs[i].quest_obj.ID = 496;
            //    diffs[i].quest_obj.padding = 0;
            //    diffs[i].something2 = 0x0B;
            //    diffs[i].questNameString = 30010;

            //    // These are likely bitfields
            //    diffs[i].something3 = 0x00030301;
            //}

            //context.SendPacket(new QuestDifficultyPacket(diffs));

            // [K873] I believe this is the correct packet, but it causes an infinite send/recieve loop, we're probably just missing something else
            context.SendPacket(new NoPayloadPacket(0x0B, 0x1C));
        }
    }

}
